﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Editors;
using Infragistics.Controls.Grids;

namespace CustomComboEditorColumn
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void XamComboEditor_ItemAdding(object sender, ComboItemAddingEventArgs<ComboEditorItem> e)
        {
            //THIS DOES NOT WORK!

            //XamComboEditor cb = e.Item.ComboEditor;

            //if (cb != null)
            //{
            //    AttributeViewModel vm = ((CellControl)cb.Parent).Cell.Row.Data as AttributeViewModel;

            //    if (vm != null)
            //    {
            //        vm.AddItem(e);
            //    }
            //}

            if (m_Cell != null)
            {
                AttributeViewModel vm = m_Cell.Row.Data as AttributeViewModel;

                if (vm != null)
                {
                    vm.AddItem(e);
                }
            }
        }

        //stores the current cell 
        private Cell m_Cell;

        private void xamGrid_CellEnteredEditMode(object sender, EditingCellEventArgs e)
        {
            if (e.Cell.Column.Key == "SelectedValue")
            {
                XamComboEditor box = e.Editor as XamComboEditor;
                if (box != null)
                {
                    Binding b = new Binding
                                    {
                                        Source = e.Cell.Row.Data,
                                        Path = new PropertyPath("Values"),
                                    };
                    box.SetBinding(XamComboEditor.ItemsSourceProperty, b);
                    m_Cell = e.Cell;

                    Binding selectedItemBinding = new Binding
                                                      {
                                                          Source = e.Cell.Row.Data,
                                                          Path = new PropertyPath(e.Cell.Column.Key),
                                                          Mode = BindingMode.TwoWay,
                                                          ValidatesOnNotifyDataErrors = true,
                                                          NotifyOnValidationError = true,
                                                          ValidatesOnDataErrors = true,
                                                          ValidatesOnExceptions = true
                                                      };

                    box.SetBinding(XamComboEditor.SelectedItemProperty, selectedItemBinding);

                    ((TemplateColumn)m_Cell.Column).AllowEditingValidation = true;
                }
            }
        }

        private void xamGrid_CellExitingEditMode(object sender, ExitEditingCellEventArgs e)
        {
            if ((e.Cell.Column.Key == "SelectedValue") && (!e.EditingCanceled))
            {
                XamComboEditor box = e.Editor as XamComboEditor;

                if (box != null)
                {
                    if (box.SelectedItem != null)
                    {
                        e.NewValue = box.SelectedItem;
                        //box.ItemsSource = null;
                        //box.SelectedItem = null;
                    }        
                }
            }

        }

    }
}
